Index: squid/src/dns_internal.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/dns_internal.c,v
retrieving revision 1.1.1.1.4.6.2.1
retrieving revision 1.1.1.1.4.6.2.2
diff -u -r1.1.1.1.4.6.2.1 -r1.1.1.1.4.6.2.2
--- squid/src/dns_internal.c	6 Jan 2001 12:40:13 -0000	1.1.1.1.4.6.2.1
+++ squid/src/dns_internal.c	14 Jun 2001 20:36:15 -0000	1.1.1.1.4.6.2.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: dns_internal.c,v 1.1.1.1.4.6.2.1 2001/01/06 12:40:13 hno Exp $
+ * $Id: dns_internal.c,v 1.1.1.1.4.6.2.2 2001/06/14 20:36:15 serassio Exp $
  *
  * DEBUG: section 78    DNS lookups; interacts with lib/rfc1035.c
  * AUTHOR: Duane Wessels
@@ -36,6 +36,9 @@
 #define DNS_INTERNAL_C
 
 #include "squid.h"
+#if defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_)
+#include <windows.h>
+#endif
 
 #if !USE_DNSSERVERS
 
@@ -85,6 +88,9 @@
 static void idnsFreeNameservers(void);
 static void idnsParseNameservers(void);
 static void idnsParseResolvConf(void);
+#if defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_)
+static void idnsParseWIN32Registry(void);
+#endif
 static void idnsSendQuery(idns_query * q);
 static int idnsFromKnownNameserver(struct sockaddr_in *from);
 static idns_query *idnsFindQuery(unsigned short id);
@@ -144,78 +150,9 @@
 static void
 idnsParseResolvConf(void)
 {
-#ifndef _SQUID_MSWIN_
     FILE *fp;
     char buf[512];
-#endif
-	char *t;
-#ifdef _SQUID_MSWIN_
-    char *token;
-	HKEY hndKey,hndKey2;
-	
-	idnsFreeNameservers();
-	// get nameservers from the registry
-  	if (RegOpenKey(HKEY_LOCAL_MACHINE,"SYSTEM\\CurrentControlSet\\Services\\Tcpip\\Parameters",&hndKey) == ERROR_SUCCESS) {
-  		DWORD Type = 0;
-  		DWORD Size = 0;
-  		LONG	Result;
-		Result = RegQueryValueEx(hndKey,"DhcpNameServer",NULL,&Type,NULL,&Size);
-		if (Result == ERROR_SUCCESS && Size) {
-			t = (unsigned char*) xmalloc(Size);
-			RegQueryValueEx(hndKey,"DhcpNameServer",NULL,&Type,t,&Size);
-		    token = strtok((char*)t,", ");
-		    while (token) {
-		    	idnsAddNameserver(token);
-		    	token = strtok(NULL,", ");
-		    }
-		}			
-		Result = RegQueryValueEx(hndKey,"NameServer",NULL,&Type,NULL,&Size);
-		if (Result == ERROR_SUCCESS && Size) {
-			t = (unsigned char*)xmalloc(Size);
-			RegQueryValueEx(hndKey,"NameServer",NULL,&Type,t,&Size);
-		    token = strtok((char*)t,", ");
-		    while (token) {
-				debug(78, 1) ("Adding nameserver %s from Registry\n", token);
-		    	idnsAddNameserver(token);
-		    	token = strtok(NULL,", ");
-		    }
-		} 
-	 	RegCloseKey(hndKey);
-	}
-	// might be windows 2000 - search all interfaces for DNS server addresses
-	// what a goddamn PITA
-  	if (RegOpenKey(HKEY_LOCAL_MACHINE,"SYSTEM\\CurrentControlSet\\Services\\Tcpip\\Parameters\\Interfaces",&hndKey) == ERROR_SUCCESS) {
-  		int i;
-  		char keyname[255];
-  		
-  		for (i=0;i < 10; i++) {
-			if (RegEnumKey(hndKey,i,(char *)&keyname,255) == ERROR_SUCCESS) {
-				char newkeyname[255];
-				
-				strcpy(newkeyname,"SYSTEM\\CurrentControlSet\\Services\\Tcpip\\Parameters\\Interfaces\\");
-				strcat(newkeyname,keyname);
-			  	if (RegOpenKey(HKEY_LOCAL_MACHINE,newkeyname,&hndKey2) == ERROR_SUCCESS) {
-			  		DWORD Type = 0;
-			  		DWORD Size = 0;
-			  		LONG	Result;
-					Result = RegQueryValueEx(hndKey2,"NameServer",NULL,&Type,NULL,&Size);
-					if (Result == ERROR_SUCCESS && Size) {
-						t =(unsigned char*) xmalloc(Size);
-						RegQueryValueEx(hndKey2,"NameServer",NULL,&Type,t,&Size);
-					    token = strtok((char*)t,", ");
-					    while (token) {
-							debug(78, 1) ("Adding nameserver %s from Registry\n", token);
-					    	idnsAddNameserver(token);
-					    	token = strtok(NULL,", ");
-					    }
-					}
-			 	 	RegCloseKey(hndKey2);
-				}					
-			}
-		}
-		RegCloseKey(hndKey);
-	}
-#else 
+    char *t;
     fp = fopen(_PATH_RESOLV_CONF, "r");
     if (fp == NULL) {
 	debug(78, 1) ("%s: %s\n", _PATH_RESOLV_CONF, xstrerror());
@@ -234,9 +171,150 @@
 	idnsAddNameserver(t);
     }
     fclose(fp);
-#endif
 }
 
+#if defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_)
+static void
+idnsParseWIN32Registry(void)
+{
+    char *t;
+    char *token;
+    HKEY hndKey, hndKey2;
+
+    idnsFreeNameservers();
+    switch (WIN32_OS_version) {
+    case _WIN_OS_WINNT:
+	/* get nameservers from the Windows NT registry */
+	if (RegOpenKey(HKEY_LOCAL_MACHINE,
+		"SYSTEM\\CurrentControlSet\\Services\\Tcpip\\Parameters",
+		&hndKey) == ERROR_SUCCESS) {
+	    DWORD Type = 0;
+	    DWORD Size = 0;
+	    LONG Result;
+	    Result =
+		RegQueryValueEx(hndKey, "DhcpNameServer", NULL, &Type, NULL,
+		&Size);
+	    if (Result == ERROR_SUCCESS && Size) {
+		t = (unsigned char *) xmalloc(Size);
+		RegQueryValueEx(hndKey, "DhcpNameServer", NULL, &Type, t,
+		    &Size);
+		token = strtok((char *) t, ", ");
+		while (token) {
+		    idnsAddNameserver(token);
+		    debug(78, 1) ("Adding DHCP nameserver %s from Registry\n",
+			token);
+		    token = strtok(NULL, ", ");
+		}
+	    }
+	    Result =
+		RegQueryValueEx(hndKey, "NameServer", NULL, &Type, NULL, &Size);
+	    if (Result == ERROR_SUCCESS && Size) {
+		t = (unsigned char *) xmalloc(Size);
+		RegQueryValueEx(hndKey, "NameServer", NULL, &Type, t, &Size);
+		token = strtok((char *) t, ", ");
+		while (token) {
+		    debug(78, 1) ("Adding nameserver %s from Registry\n",
+			token);
+		    idnsAddNameserver(token);
+		    token = strtok(NULL, ", ");
+		}
+	    }
+	    RegCloseKey(hndKey);
+	}
+	break;
+    case _WIN_OS_WIN2K:
+	/* get nameservers from the Windows 2000 registry */
+	/* search all interfaces for DNS server addresses */
+	if (RegOpenKey(HKEY_LOCAL_MACHINE,
+		"SYSTEM\\CurrentControlSet\\Services\\Tcpip\\Parameters\\Interfaces",
+		&hndKey) == ERROR_SUCCESS) {
+	    int i;
+	    char keyname[255];
+
+	    for (i = 0; i < 10; i++) {
+		if (RegEnumKey(hndKey, i, (char *) &keyname,
+			255) == ERROR_SUCCESS) {
+		    char newkeyname[255];
+		    strcpy(newkeyname,
+			"SYSTEM\\CurrentControlSet\\Services\\Tcpip\\Parameters\\Interfaces\\");
+		    strcat(newkeyname, keyname);
+		    if (RegOpenKey(HKEY_LOCAL_MACHINE, newkeyname,
+			    &hndKey2) == ERROR_SUCCESS) {
+			DWORD Type = 0;
+			DWORD Size = 0;
+			LONG Result;
+			Result =
+			    RegQueryValueEx(hndKey2, "DhcpNameServer", NULL,
+			    &Type, NULL, &Size);
+			if (Result == ERROR_SUCCESS && Size) {
+			    t = (unsigned char *) xmalloc(Size);
+			    RegQueryValueEx(hndKey2, "DhcpNameServer", NULL,
+				&Type, t, &Size);
+			    token = strtok((char *) t, ", ");
+			    while (token) {
+				debug(78, 1)
+				    ("Adding DHCP nameserver %s from Registry\n",
+				    token);
+				idnsAddNameserver(token);
+				token = strtok(NULL, ", ");
+			    }
+			}
+			Result =
+			    RegQueryValueEx(hndKey2, "NameServer", NULL, &Type,
+			    NULL, &Size);
+			if (Result == ERROR_SUCCESS && Size) {
+			    t = (unsigned char *) xmalloc(Size);
+			    RegQueryValueEx(hndKey2, "NameServer", NULL, &Type,
+				t, &Size);
+			    token = strtok((char *) t, ", ");
+			    while (token) {
+				debug(78,
+				    1) ("Adding nameserver %s from Registry\n",
+				    token);
+				idnsAddNameserver(token);
+				token = strtok(NULL, ", ");
+			    }
+			}
+			RegCloseKey(hndKey2);
+		    }
+		}
+	    }
+	    RegCloseKey(hndKey);
+	}
+	break;
+    case _WIN_OS_WIN95:
+    case _WIN_OS_WIN98:
+	/* get nameservers from the Windows 9X registry */
+	if (RegOpenKey(HKEY_LOCAL_MACHINE,
+		"SYSTEM\\CurrentControlSet\\Services\\VxD\\MSTCP",
+		&hndKey) == ERROR_SUCCESS) {
+	    DWORD Type = 0;
+	    DWORD Size = 0;
+	    LONG Result;
+	    Result =
+		RegQueryValueEx(hndKey, "NameServer", NULL, &Type, NULL, &Size);
+	    if (Result == ERROR_SUCCESS && Size) {
+		t = (unsigned char *) xmalloc(Size);
+		RegQueryValueEx(hndKey, "NameServer", NULL, &Type, t, &Size);
+		token = strtok((char *) t, ", ");
+		while (token) {
+		    debug(78, 1) ("Adding nameserver %s from Registry\n",
+			token);
+		    idnsAddNameserver(token);
+		    token = strtok(NULL, ", ");
+		}
+	    }
+	    RegCloseKey(hndKey);
+	}
+	break;
+    default:
+	debug(78, 1)
+	    ("Failed to read nameserver from Registry: Unknown System Type.\n");
+	return;
+    }
+}
+#endif
+
 static void
 idnsStats(StoreEntry * sentry)
 {
@@ -508,7 +586,7 @@
     if (DnsSocket < 0) {
 	DnsSocket = comm_open(SOCK_DGRAM,
 #ifdef _SQUID_MSWIN_
-		IPPROTO_UDP,
+	    IPPROTO_UDP,
 #else
 	    0,
 #endif
@@ -522,11 +600,21 @@
     }
     assert(0 == nns);
     idnsParseNameservers();
+#ifndef _SQUID_MSWIN_
     if (0 == nns)
 	idnsParseResolvConf();
+#endif
+#if defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_)
+    if (0 == nns)
+	idnsParseWIN32Registry();
+#endif
     if (0 == nns)
 	fatal("Could not find any nameservers.\n"
+#if defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_)
+	    "       Please check your TCP-IP settings or /etc/resolv.conf file\n"
+#else
 	    "       Please check your /etc/resolv.conf file\n"
+#endif
 	    "       or use the 'dns_nameservers' option in squid.conf.");
     if (!init) {
 	memDataInit(MEM_IDNS_QUERY, "idns_query", sizeof(idns_query), 0);
Index: squid/src/globals.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/globals.h,v
retrieving revision 1.1.1.3.4.2.2.2
retrieving revision 1.1.1.3.4.2.2.3
diff -u -r1.1.1.3.4.2.2.2 -r1.1.1.3.4.2.2.3
--- squid/src/globals.h	25 Mar 2001 16:42:23 -0000	1.1.1.3.4.2.2.2
+++ squid/src/globals.h	14 Jun 2001 20:36:16 -0000	1.1.1.3.4.2.2.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: globals.h,v 1.1.1.3.4.2.2.2 2001/03/25 16:42:23 serassio Exp $
+ * $Id: globals.h,v 1.1.1.3.4.2.2.3 2001/06/14 20:36:16 serassio Exp $
  *
  *
  * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
@@ -157,3 +157,9 @@
 extern request_flags null_request_flags;
 extern int store_open_disk_fd;	/* 0 */
 extern const char *SwapDirType[];
+#if defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_)
+extern unsigned int WIN32_OS_version;	/* 0 */
+extern char *WIN32_OS_string;
+extern char *WIN32_Service_name; /* NULL */
+extern unsigned int WIN32_run_mode;	/* _WIN_SQUID_RUN_MODE_INTERACTIVE */
+#endif
